#include<stdio.h>
#include<stdlib.h>
#include <string.h>
#include <strings.h>
#include<malloc.h>
#include <unistd.h>

#define MAX_STRESS 1000000000.

int  create_socket(int *, int, int);
int  compute(float, float, float, float, float*);

int *descriptor;

int main(int argc, char** argv) {
	int i, port, clients, connection;
	float young;
	float area;
	float length;
	float force;
	float new_length;

	float stress;
	float strain;

/*
 *      Parse command line arguments and create a socket
 *
 */

	for (i=1;i<argc - 1;i++) {
		if (strcmp(*(argv+i),"-p") == 0) {      /* Port switch */
			i++;
			port = atoi(*(argv + i));       /* Set port to the command line argument */
		}
		if (strcmp(*(argv+i),"-c") == 0) {      /* Clients switch */
			i++;
			clients = atoi(*(argv + i));    /* Set number of concurrent clients to the command line argument */
		}
	}

	if (!port || !clients) {
		printf("Usage: %s -p port -c clients\n\n",*argv);
		printf("\t-p port\t\tport to listen for incomming clients\n");
		printf("\t-c clients\tmaximum number of concurrent clients\n");
		exit(0);
	}

	descriptor = (int *) malloc(clients * sizeof(int));
	if (create_socket(descriptor, port, clients) <= 0) {
		printf("Error: Unable to create socket\n");
		exit(0);
	}

/*
 *      Arguments Parsed, Socket Created, Code Continues...
 *
 */
	
	read(*(descriptor+0), (char *) &young, sizeof(float));
	read(*(descriptor+0), (char *) &area, sizeof(float));
	read(*(descriptor+0), (char *) &length, sizeof(float));
	write(*(descriptor+1), (char *) &length, sizeof(float));
	printf("I got: %f %f %f\n", young, area, length);

	do {
		/* Read values from Labview */
		read(*(descriptor+0), (char *) &force, sizeof(float));
		printf("got force = %f\n", force );

		compute(young, area, length, force, &new_length);
		stress = force/area;
		strain = new_length / length;

		/* Send computed values to clients */
		write(*(descriptor+1), (char *) &stress, sizeof(float));
		write(*(descriptor+1), (char *) &strain, sizeof(float));
		write(*(descriptor+0), (char *) &strain, sizeof(float));
		printf("\tSending stress, strain = %f %f\n", stress, strain);

		/* Check if Labview has disconnected, send to Inventor */
		read(*(descriptor+0), (char *) &connection, sizeof(int));
		printf("here\n");
		write(*(descriptor+0), (char *) &connection, sizeof(int));
		printf("\there\n");
		write(*(descriptor+1), (char *) &connection, sizeof(int));
		printf("\t\there\n");
		read(*(descriptor+1), (char *) &connection, sizeof(int));
		printf("\t\t\there\n");
	} while (connection);

	for (i=0;i<clients;i++) close(*(descriptor+i));

	return 0;
}
